import random
import math

def preSyn(file):
    #writes the Syntax before the light-sources
    file.write('<terragen_clip>\n    <null\n        name = "Stars"\n        gui_use_node_pos = "1"\n        gui_node_pos = "300 -220 0"\n        gui_group = ""\n        enable = "1"\n        position = "0 0 0"\n        rotation = "0 0 0"\n        import_motion_filename = ""\n        heading = "0"\n        elevation = "0"\n        distance = "0"\n        >')

def postSyn(file):
    #writes the Syntax after the light-sources
    file.write('    </null>\n</terragen_clip>')

def makeLight(i, file, rXZ, rY, minStrength, maxStrength, minMaxDistance, maxMaxDistance, castShadows, shadowsOfAtmosphere):
    #writes a light-source with the given parameters, randomizing a few options
    file.write('        <light_source\n')
    file.write('            name = "lightsource '+str(i)+'"\n')
    file.write('            gui_use_node_pos = "1"\n')
    file.write('            gui_node_pos = "0 '+str(i)+' 0"\n')
    file.write('            gui_group = ""\n')
    file.write('            enable = "1"\n')
    file.write('            source_centre = "'+new_position(rXZ, rY)+'"\n')
    file.write('            source_radius = "0"\n')
    file.write('            rotate = "0 0 0"\n')
    file.write('            colour = "1 1 1"\n')
    file.write('            strength = "'+str(random.randint(minStrength, maxStrength))+'"\n')
    file.write('            max_distance = "'+str(random.randint(minMaxDistance, maxMaxDistance))+'"\n')
    file.write('            cast_shadows = "'+str(castShadows)+'"\n')
    file.write('            shadows_of_surfaces = "0"\n')
    file.write('            shadows_of_atmosphere = "'+str(shadowsOfAtmosphere)+'"\n')
    file.write('            soft_shadows = "0"\n')
    file.write('            soft_shadow_samples = "0"\n')
    file.write('            glow_in_atmosphere = "1"\n')
    file.write('            specular_highlights = "0"\n')
    file.write('            visible_object = "0"\n')
    file.write('            import_motion_filename = ""\n')
    file.write('            >\n')
    file.write('        </light_source>\n')

def new_position(rXZ, rY):
    phi = random.uniform(0,2*math.pi)
    theta = math.acos(random.uniform(-1,1))
    r = random.uniform(0.0,1.0)
    x = r * math.sin( theta) * math.cos( phi )* rXZ
    y = r * math.sin( theta) * math.sin( phi )* rY
    z = r * math.cos( theta )* rXZ
    s = str(int(x))+' '+ str(int(y))+' '+str(int(z))
    return (s)

#Main program
#Input Options
imax = int(input('Number of Stars: '))
rXZ = int(input('Radius on x and z : '))
rY = int(input('Radius on y : '))
minStrength = int(input('Minimum Strength: '))
maxStrength = int(input('Maximum Strength: '))
minMaxDistance = int(input('min Maximum Distance: '))
maxMaxDistance = int(input('max Maximum Distance: '))
castShadows = int(input('Casting Shadows? (1 or 0): '))
shadowsOfAtmosphere = int(input('Shadows in Atmosphere? (1 or 0): '))

file = open('stars.tgc', 'w')
preSyn(file)
i=0
while (i<imax):
    makeLight(i, file, rXZ, rY, minStrength, maxStrength, minMaxDistance, maxMaxDistance, castShadows, shadowsOfAtmosphere)
    i+=1
    print(''+str(i)+' of '+str(imax)+' done')
postSyn(file)
file.close()
print('done')


